_G[gTable] = {};

local aTmpVal     = gTable;
local aInfoShown  = false;
local aCount      = 0;
cm.SetupTable(_G[aTmpVal]);

-- Called on Init
_G[gTable].OnInit = function(pObj)

   pObj.mState = 0;
	aInfoShown = false;
	aCount = 0;
	pObj.mCsData:SetVal("aInfoShown", aInfoShown);

   local aGflag = pObj.mCsData:GetString("ActivatorFlag1");
   pObj.mPdata.mCsData:SetVal(aGflag, false);

end

-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)
	aInfoShown = pObj.mCsData:GetBool("aInfoShown");
	aCount = 0;
end

-- Called after a level is loaded
_G[gTable].OnLevelLoad = function(pObj)
   pObj.mGobj.mSoundPlayer:PlayMusic("IcMusicTalkingHeads", 2000, 0.02, 0.02, true);
   pObj.mGobj.mSoundPlayer:PlayAmbient("Ambient_BuilderInsides", 10);
   aInfoShown = pObj.mCsData:GetBool("aInfoShown");
end

-- Called after a level is exited
_G[gTable].OnLevelExit = function(pObj)
   pObj.mGobj.mSoundPlayer:ClearMusic(0);
   pObj.mGobj.mSoundPlayer:FadeoutAmbient(20);
end


-- Called on a update
_G[gTable].OnUpdate = function(pObj)

	if not aInfoShown then
		aCount = aCount + 1;
		if aCount == 25 then
			aInfoShown = true;
			pObj.mCsData:SetVal("aInfoShown", aInfoShown);
			--pObj.mPdata:ShowCurLevelInfo();
			pObj.mPdata:ShowCurLevelInfo("PH_SFX_INGAME_07");
		end
	end
	
	if pObj.mState == 0 then
      local aGflag = pObj.mCsData:GetString("ActivatorFlag1");
   	if pObj.mPdata.mCsData:GetBool(aGflag) then
         pObj.mState = pObj.mState + 1;
         pObj:SetActive(0, 0, true);
   	end
	end

end

-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)

	if pName == "" then

      if pPolyNum == 0 then
      	local aNextLevel = pObj.mCsData:GetInt("NextLevel1");
      	pObj.mPdata:SetNextLevel(aNextLevel);
      	pObj.mPdata:LevelComplete(pObj.mCsData:GetBool("NextStage"));

   	elseif pPolyNum == 1 then
      	local aNextLevel = pObj.mCsData:GetInt("NextLevel2");
      	pObj.mPdata:SetNextLevel(aNextLevel);
      	pObj.mPdata:LevelComplete(pObj.mCsData:GetBool("NextStage"));
   	end
		IcPlaySample("PH_SFX_OBJ_PICKUP");
      return true;

   else
 		cm.ObjDoesNotWork(pObj);
		return false;
  end

   return false;
end

-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)

	local aImg = IcImageWrap(pObj.mSmallImage);
	if (pObj.mCurImg == 1) then
		aImg = IcImageWrap(pObj.mBigImage);
	end
	assert(aImg);

	aRect = aImg:GetCelRect(pObj.mCurCell);
	if pObj:SmIsMoving() then
		pG:DrawImageF(aImg:GetImage(), pObj.mSmPos.x, pObj.mSmPos.y, aRect);
	else
		pG:DrawImage(aImg:GetImage(), pObj.mSmPos.x, pObj.mSmPos.y, aRect);
	end

end


-- Called on moused
_G[gTable].OnMoused =  function(pObj)

end

-- Called on Unmoused
_G[gTable].OnUnMoused =  function(pObj)

end

